Vue Tooltip Component and Directive

Tooltip

Documentation and examples for adding Vue Tooltips.

Available in Other JavaScript Frameworks

CoreUI Vue Tooltip Component and Directive is also available for Angular, Bootstrap, and React. Explore framework-specific implementations below:

Examples

Hover over the links below to see tooltips:

vue
<template>
  <p class="text-body-secondary">
    Tight pants next level keffiyeh
    <CLink v-c-tooltip="'Tooltip text'"> you&nbsp;probably </CLink>
    haven't heard of them. Photo booth beard raw denim letterpress vegan messenger bag stumptown.
    Farm-to-table seitan, mcsweeney's fixie sustainable quinoa 8-bit american apparel
    <CLink v-c-tooltip="'Tooltip text'"> have&nbsp;a </CLink>
    terry richardson vinyl chambray. Beard stumptown, cardigans banh mi lomo thundercats. Tofu
    biodiesel williamsburg marfa, four loko mcsweeney''s cleanse vegan chambray. A really ironic
    artisan
    <CLink v-c-tooltip="'Tooltip text'"> whatever&nbsp;keytar </CLink>
    scenester farm-to-table banksy Austin
    <CLink v-c-tooltip="'Tooltip text'"> twitter&nbsp;handle </CLink>
    freegan cred raw denim single-origin coffee viral.
  </p>
</template>

<script setup>
import { CLink, vctooltip as vCTooltip } from '@coreui/vue'
</script>

Component

Hover over the buttons below to see the four tooltips directions: top, right, bottom, and left. Directions are mirrored when using CoreUI in RTL.

vue
<template>
  <CTooltip content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus" placement="top">
    <template #toggler="{ id, on }">
      <CButton color="secondary" :aria-describedby="id" v-on="on">Tooltip on top</CButton>
    </template>
  </CTooltip>
  <CTooltip content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus" placement="right">
    <template #toggler="{ id, on }">
      <CButton color="secondary" :aria-describedby="id" v-on="on">Tooltip on right</CButton>
    </template>
  </CTooltip>
  <CTooltip content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus" placement="bottom">
    <template #toggler="{ id, on }">
      <CButton color="secondary" :aria-describedby="id" v-on="on">Tooltip on bottom</CButton>
    </template>
  </CTooltip>
  <CTooltip content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus" placement="left">
    <template #toggler="{ id, on }">
      <CButton color="secondary" :aria-describedby="id" v-on="on">Tooltip on left</CButton>
    </template>
  </CTooltip>
</template>

<script setup>
import { CTooltip, CButton } from '@coreui/vue'
</script>

Directive

vue
<template>
  <CButton
    v-c-tooltip="{
      content: 'Vivamus sagittis lacus vel augue laoreet rutrum faucibus.',
      placement: 'top',
    }"
    color="secondary"
    >Tooltip on top</CButton
  >
  <CButton
    v-c-tooltip="{
      content: 'Vivamus sagittis lacus vel augue laoreet rutrum faucibus.',
      placement: 'right',
    }"
    color="secondary"
    >Tooltip on right</CButton
  >
  <CButton
    v-c-tooltip="{
      content: 'Vivamus sagittis lacus vel augue laoreet rutrum faucibus.',
      placement: 'bottom',
    }"
    color="secondary"
    >Tooltip on bottom</CButton
  >
  <CButton
    v-c-tooltip="{
      content: 'Vivamus sagittis lacus vel augue laoreet rutrum faucibus.',
      placement: 'left',
    }"
    color="secondary"
    >Tooltip on left</CButton
  >
</template>

<script setup>
import { CButton, vctooltip as vCTooltip } from '@coreui/vue'
</script>

Custom tooltips

You can customize the appearance of tooltips using CSS variables. We set a custom style to scope our custom appearance and use it to override some of the local CSS variables.

vue
<template>
  <CTooltip
    content="This top tooltip is themed via CSS variables."
    placement="top"
    :style="customTooltipStyle"
  >
    <template #toggler="{ id, on }">
      <CButton color="secondary" :aria-describedby="id" v-on="on">Custom tooltip</CButton>
    </template>
  </CTooltip>
</template>

<script setup>
import { CTooltip, CButton } from '@coreui/vue'
const customTooltipStyle = {
  '--cui-tooltip-bg': 'var(--cui-primary)',
}
</script>

Usage

Disabled elements

Elements with the disabled attribute aren’t interactive, meaning users cannot focus, hover, or click them to trigger a tooltip (or popover). As a workaround, you’ll want to trigger the tooltip from a wrapper <div> or <span>, ideally made keyboard-focusable using tabindex="0".

vue
<template>
  <CTooltip content="Disabled tooltip">
    <template #toggler="{ id, on }">
      <span class="d-inline-block" :tabindex="0" :aria-describedby="id" v-on="on">
        <CButton color="primary" disabled>Disabled button</CButton>
      </span>
    </template>
  </CTooltip>
</template>

<script setup>
import { CTooltip, CButton } from '@coreui/vue'
</script>

API

Check out the documentation below for a comprehensive guide to all the props you can use with the components mentioned here.

React Tooltip Component

Tooltip

Documentation and examples for adding React Tooltips.

Available in Other JavaScript Frameworks

CoreUI React Tooltip Component is also available for Angular, Bootstrap, and Vue. Explore framework-specific implementations below:

Examples

Hover over the links below to see tooltips:

import React from 'react'
import { CLink, CTooltip } from '@coreui/react'

export const TooltipOnLinksExample = () => {
  return (
    <p className="text-body-secondary">
      Tight pants next level keffiyeh
      <CTooltip content="Tooltip text">
        <CLink> you probably </CLink>
      </CTooltip>
      haven&#39;t heard of them. Photo booth beard raw denim letterpress vegan messenger bag
      stumptown. Farm-to-table seitan, mcsweeney&#39;s fixie sustainable quinoa 8-bit american
      apparel
      <CTooltip content="Tooltip text">
        <CLink> have a </CLink>
      </CTooltip>
      terry richardson vinyl chambray. Beard stumptown, cardigans banh mi lomo thundercats. Tofu
      biodiesel williamsburg marfa, four loko mcsweeney&#39;s cleanse vegan chambray. A really
      ironic artisan
      <CTooltip content="Tooltip text">
        <CLink> whatever keytar </CLink>
      </CTooltip>
      scenester farm-to-table banksy Austin
      <CTooltip content="Tooltip text">
        <CLink> twitter handle </CLink>
      </CTooltip>
      freegan cred raw denim single-origin coffee viral.
    </p>
  )
}
import React from 'react'
import { CLink, CTooltip } from '@coreui/react'

export const TooltipOnLinksExample = () => {
  return (
    <p className="text-body-secondary">
      Tight pants next level keffiyeh
      <CTooltip content="Tooltip text">
        <CLink> you probably </CLink>
      </CTooltip>
      haven&#39;t heard of them. Photo booth beard raw denim letterpress vegan messenger bag
      stumptown. Farm-to-table seitan, mcsweeney&#39;s fixie sustainable quinoa 8-bit american
      apparel
      <CTooltip content="Tooltip text">
        <CLink> have a </CLink>
      </CTooltip>
      terry richardson vinyl chambray. Beard stumptown, cardigans banh mi lomo thundercats. Tofu
      biodiesel williamsburg marfa, four loko mcsweeney&#39;s cleanse vegan chambray. A really
      ironic artisan
      <CTooltip content="Tooltip text">
        <CLink> whatever keytar </CLink>
      </CTooltip>
      scenester farm-to-table banksy Austin
      <CTooltip content="Tooltip text">
        <CLink> twitter handle </CLink>
      </CTooltip>
      freegan cred raw denim single-origin coffee viral.
    </p>
  )
}

Custom tooltips

You can customize the appearance of tooltips using CSS variables. We set a custom style to scope our custom appearance and use it to override some of the local CSS variables.

import React from 'react'
import { CButton, CTooltip } from '@coreui/react'

export const TooltipCustomExample = () => {
  const customTooltipStyle = {
    '--cui-tooltip-bg': 'var(--cui-primary)',
  } as React.CSSProperties

  return (
    <CTooltip
      content="This top tooltip is themed via CSS variables."
      placement="top"
      style={customTooltipStyle}
    >
      <CButton color="secondary">Custom tooltip</CButton>
    </CTooltip>
  )
}
import React from 'react'
import { CButton, CTooltip } from '@coreui/react'

export const TooltipCustomExample = () => {
  const customTooltipStyle = {
    '--cui-tooltip-bg': 'var(--cui-primary)',
  }

  return (
    <CTooltip
      content="This top tooltip is themed via CSS variables."
      placement="top"
      style={customTooltipStyle}
    >
      <CButton color="secondary">Custom tooltip</CButton>
    </CTooltip>
  )
}

Directions

Hover over the buttons below to see the four tooltips directions: top, right, bottom, and left. Directions are mirrored when using CoreUI in RTL.

import React from 'react'
import { CButton, CTooltip } from '@coreui/react'

export const TooltipDirectionsExample = () => {
  return (
    <>
      <CTooltip content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus." placement="top">
        <CButton color="secondary">Tooltip on top</CButton>
      </CTooltip>
      <CTooltip
        content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus."
        placement="right"
      >
        <CButton color="secondary">Tooltip on right</CButton>
      </CTooltip>
      <CTooltip
        content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus."
        placement="bottom"
      >
        <CButton color="secondary">Tooltip on bottom</CButton>
      </CTooltip>
      <CTooltip
        content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus."
        placement="left"
      >
        <CButton color="secondary">Tooltip on left</CButton>
      </CTooltip>
    </>
  )
}
import React from 'react'
import { CButton, CTooltip } from '@coreui/react'

export const TooltipDirectionsExample = () => {
  return (
    <>
      <CTooltip content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus." placement="top">
        <CButton color="secondary">Tooltip on top</CButton>
      </CTooltip>
      <CTooltip
        content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus."
        placement="right"
      >
        <CButton color="secondary">Tooltip on right</CButton>
      </CTooltip>
      <CTooltip
        content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus."
        placement="bottom"
      >
        <CButton color="secondary">Tooltip on bottom</CButton>
      </CTooltip>
      <CTooltip
        content="Vivamus sagittis lacus vel augue laoreet rutrum faucibus."
        placement="left"
      >
        <CButton color="secondary">Tooltip on left</CButton>
      </CTooltip>
    </>
  )
}

Usage

A shown tooltip can be dismissed by pressing the Escape key, helping satisfy the WCAG 1.4.13 “Content on Hover or Focus” success criterion.

Disabled elements

Elements with the disabled attribute aren’t interactive, meaning users cannot focus, hover, or click them to trigger a tooltip (or popover). As a workaround, you’ll want to trigger the tooltip from a wrapper <div> or <span>, ideally made keyboard-focusable using tabindex="0".

import React from 'react'
import { CButton, CTooltip } from '@coreui/react'

export const TooltipDisabledElementsExample = () => {
  return (
    <CTooltip content="Disabled tooltip" trigger={['hover', 'focus']}>
      <span className="d-inline-block" tabIndex={0}>
        <CButton color="primary" disabled>
          Disabled button
        </CButton>
      </span>
    </CTooltip>
  )
}
import React from 'react'
import { CButton, CTooltip } from '@coreui/react'

export const TooltipDisabledElementsExample = () => {
  return (
    <CTooltip content="Disabled tooltip" trigger={['hover', 'focus']}>
      <span className="d-inline-block" tabIndex={0}>
        <CButton color="primary" disabled>
          Disabled button
        </CButton>
      </span>
    </CTooltip>
  )
}

API

Check out the documentation below for a comprehensive guide to all the props you can use with the components mentioned here.

Angular Tooltip Component

Tooltip

Documentation and examples for adding Angular Tooltips.

Available in Other JavaScript Frameworks

CoreUI Angular Tooltip Component is also available for Bootstrap, React, and Vue. Explore framework-specific implementations below:

Use CoreUI Angular tooltip directive to create beautiful tooltips and present hint or information regarding the element on hover. Tutorials and examples for adding custom CoreUI Angular tooltips.

Examples

Base tooltips

  • Hover over the links below to see tooltips:
import { Component } from '@angular/core';
import { RouterLink } from '@angular/router';
import { TooltipDirective } from '@coreui/angular';

@Component({
  selector: 'docs-tooltip-base-tooltips',
  templateUrl: './tooltip-base-tooltips.component.html',
  imports: [TooltipDirective, RouterLink]
})
export class TooltipBaseTooltipsComponent {}
<p class="text-medium-emphasis">
  Tight pants next level keffiyeh
  <a cTooltip="Tooltip text" [cTooltipVisible]="true" routerLink> you probably </a>
  haven&#39;t heard of them. Photo booth beard raw denim letterpress vegan messenger
  bag stumptown.
  <a cTooltip="Tooltip text" routerLink>Twitter handle</a> freegan cred raw denim single-origin coffee viral.
</p>

Directions

  • Hover over the buttons below to see the four tooltips directions: top, right, bottom, and left. Directions are mirrored when using CoreUI in RTL.
import { Component } from '@angular/core';
import { ButtonDirective, TooltipDirective } from '@coreui/angular';

@Component({
  selector: 'docs-tooltip-directions',
  templateUrl: './tooltip-directions.component.html',
  imports: [ButtonDirective, TooltipDirective]
})
export class TooltipDirectionsComponent {
  tooltipText = 'Vivamus sagittis lacus vel augue laoreet rutrum faucibus.';
}
<button cButton [cTooltip]="tooltipText" cTooltipPlacement="top" class="me-1" color="secondary">
  Tooltip on top
</button>
<button cButton [cTooltip]="tooltipText" cTooltipPlacement="right" class="me-1" color="secondary">
  Tooltip on right
</button>
<button cButton [cTooltip]="tooltipText" cTooltipPlacement="bottom" class="me-1" color="secondary">
  Tooltip on bottom
</button>
<button cButton [cTooltip]="tooltipText" cTooltipPlacement="left" class="me-1" color="secondary">
  Tooltip on left
</button>

Html content

  • Use ng-template to render html content and / or non default triggers (click).
import { Component } from '@angular/core';
import { ButtonDirective, TextColorDirective, TooltipDirective } from '@coreui/angular';

@Component({
  selector: 'docs-tooltip-html-content',
  templateUrl: './tooltip-html-content.component.html',
  imports: [ButtonDirective, TooltipDirective, TextColorDirective]
})
export class TooltipHtmlContentComponent {}
<button
  [cTooltip]="tooltipContent"
  cButton
  cTooltipPlacement="right"
  cTooltipTrigger="click"
  class="me-1"
  color="secondary">
  Template Tooltip
  <ng-template #tooltipContent>
    Vivamus <span cTextColor="success">sagittis</span> lacus vel augue laoreet
    rutrum <i cTextColor="warning">faucibus</i>.
  </ng-template>
</button>

Reference element

  • Use cTooltipRef to position the tooltip on reference element. 5.1.0+
import { Component } from '@angular/core';
import { ButtonDirective, ElementRefDirective, TooltipDirective } from '@coreui/angular';

@Component({
  selector: 'docs-tooltip-reference-element',
  imports: [ButtonDirective, TooltipDirective, ElementRefDirective],
  template: `
    <button cButton #reference="cElementRef" cElementRef disabled>Reference</button>

    <button cButton [cTooltip]="tooltipText" color="secondary" [cTooltipRef]="reference">Tooltip on reference</button>
  `
})
export class TooltipReferenceElementComponent {
  tooltipText = 'Vivamus sagittis lacus vel augue laoreet rutrum faucibus.';
}

Disabled elements

Elements with the disabled attribute aren’t interactive, meaning users cannot focus, hover, or click them to trigger a tooltip (or popover). As a workaround, you’ll want to trigger the tooltip from a wrapper div or span, ideally made keyboard-focusable using tabindex="0".

import { Component } from '@angular/core';
import { ButtonDirective, TooltipDirective } from '@coreui/angular';

@Component({
  selector: 'docs-tooltip-disabled-elements',
  imports: [ButtonDirective, TooltipDirective],
  template: `
    <span class="d-inline-block" tabindex="0" [cTooltip]="tooltipText" [cTooltipTrigger]="['hover', 'focus']">
      <button cButton color="secondary" disabled>Disabled button</button>
    </span>
  `
})
export class TooltipDisabledElementsComponent {
  tooltipText = 'Disabled element tooltip';
}

Usage

A shown tooltip can be dismissed by pressing the Escape key, helping satisfy the WCAG 1.4.13 “Content on Hover or Focus” success criterion.

API reference

Tooltip Module

import { TooltipModule } from '@coreui/angular';

@NgModule({
    imports: [TooltipModule,]
})
export class AppModule() { }

cTooltip

directive

jsx
import { TooltipDirective } from '@coreui/angular'

Props

PropertyDefaultType
cTooltipundefinedstring, TemplateRef<any>

Content of tooltip

cTooltipOptions{}Partial<Options>

Optional popper Options object, takes precedence over cPopoverPlacement prop

cTooltipPlacement'top''top', 'bottom', 'left', 'right'

Describes the placement of your component after Popper.js has applied all the modifiers that may have flipped or altered the originally provided placement property.

cTooltipRef5.1.0+undefinedElementRefDirective

ElementRefDirective for positioning the tooltip on reference element

cTooltipTrigger'hover'Triggers, Triggers[]

Sets which event handlers you’d like provided to your toggle prop. You can specify one trigger or an array of them.

cTooltipVisiblefalseboolean

Toggle the visibility of tooltip component.

Events

Event name
cTooltipVisibleChange

Emitted when cTooltipVisible changes.

  • $event boolean